<?php
class ControllerExtensionCaptchaRecaptcha extends Controller {
	private $error = array();

	public function index() {
		$this->load->language('extension/captcha/recaptcha');

		$this->document->setTitle($this->language->get('heading_title'));

		$this->load->model('setting/setting');

		if (($this->request->server['REQUEST_METHOD'] == 'POST') && $this->validate()) {
			$this->model_setting_setting->editSetting('captcha_recaptcha', $this->request->post);

			$this->session->data['success'] = $this->language->get('text_success');

			$this->response->redirect($this->url->link('marketplace/extension', 'user_token=' . $this->session->data['user_token'] . '&type=captcha', true));
		}

		if (isset($this->error['warning'])) {
			$data['error_warning'] = $this->error['warning'];
		} else {
			$data['error_warning'] = '';
		}

		if (isset($this->error['key'])) {
			$data['error_key'] = $this->error['key'];
		} else {
			$data['error_key'] = '';
		}

		if (isset($this->error['secret'])) {
			$data['error_secret'] = $this->error['secret'];
		} else {
			$data['error_secret'] = '';
		}

		if (isset($this->error['secretkey'])) {
			$data['error_secretkey'] = $this->error['secretkey'];
		} else {
			$data['error_secretkey'] = '';
		}

		if (isset($this->error['sitekey'])) {
			$data['error_sitekey'] = $this->error['sitekey'];
		} else {
			$data['error_sitekey'] = '';
		}

		$data['breadcrumbs'] = array();

		$data['breadcrumbs'][] = array(
			'text' => $this->language->get('text_home'),
			'href' => $this->url->link('common/dashboard', 'user_token=' . $this->session->data['user_token'], true)
		);

		$data['breadcrumbs'][] = array(
			'text' => $this->language->get('text_extension'),
			'href' => $this->url->link('marketplace/extension', 'user_token=' . $this->session->data['user_token'] . '&type=captcha', true)
		);

		$data['breadcrumbs'][] = array(
			'text' => $this->language->get('heading_title'),
			'href' => $this->url->link('extension/captcha/recaptcha', 'user_token=' . $this->session->data['user_token'], true)
		);

		$data['action'] = $this->url->link('extension/captcha/recaptcha', 'user_token=' . $this->session->data['user_token'], true);

		$data['cancel'] = $this->url->link('marketplace/extension', 'user_token=' . $this->session->data['user_token'] . '&type=captcha', true);

		if (isset($this->request->post['captcha_recaptcha_secretkey'])) {
			$data['secretkey'] = $this->request->post['captcha_recaptcha_secretkey'];
		} else {
			$data['secretkey'] = $this->config->get('captcha_recaptcha_secretkey');
		}
    
		if (isset($this->request->post['captcha_recaptcha_sitekey'])) {
			$data['sitekey'] = $this->request->post['captcha_recaptcha_sitekey'];
		} else {
			$data['sitekey'] = $this->config->get('captcha_recaptcha_sitekey');
		}

		if (isset($this->request->post['captcha_recaptcha_score'])) {
			$data['score'] = $this->request->post['captcha_recaptcha_score'];
		} else {
			$data['score'] = $this->config->get('captcha_recaptcha_score');
		}

		if (isset($this->request->post['captcha_recaptcha_status'])) {
			$data['captcha_recaptcha_status'] = $this->request->post['captcha_recaptcha_status'];
		} else {
			$data['captcha_recaptcha_status'] = $this->config->get('captcha_recaptcha_status');
		}

		$data['header'] = $this->load->controller('common/header');
		$data['column_left'] = $this->load->controller('common/column_left');
		$data['footer'] = $this->load->controller('common/footer');

		$this->response->setOutput($this->load->view('extension/captcha/recaptcha', $data));
	}

	protected function validate() {
		if (!$this->user->hasPermission('modify', 'extension/captcha/recaptcha')) {
			$this->error['warning'] = $this->language->get('error_permission');
		}

		if (!$this->request->post['captcha_recaptcha_secretkey']) {
			$this->error['secretkey'] = $this->language->get('error_secretkey');
		}

		if (!$this->request->post['captcha_recaptcha_sitekey']) {
			$this->error['sitekey'] = $this->language->get('error_sitekey');
		}

		return !$this->error;
	}
}
